import usb
def find_board():
  board = None
  for bus in usb.busses():
    for dev in bus.devices:
      if dev.idVendor == 0x16c0 and dev.idProduct == 0x05dc:
        return dev
  return None

def SetLED ():
  req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
  no = input("Enter LED no (0-2) : ")
  #no = raw_input()
  turn = input("Turn it on or off (0 = off , 1 = on) : ")
  #turn = raw_input()
  if (no == 0):
    if (turn == 0):
      val = 0x0000
    else : val = 0x0100
  elif (no == 1):
    if (turn == 0):
      val = 0x0001
    else: val = 0x0101
  elif(no==2):
    if (turn == 0):
      val = 0x0002
    else: val = 0x0102
  elif(no==3):
    if(turn==0):
      val =0x0003
    else: val = 0x0103
  elif(no==5):
    if(turn==0):
      val =0x0005
    else: val = 0x0105
  

  handle.controlMsg(req, 0 , None , value = val)
  raw_input()

def SwStat():
 
  lv=0
  while (1):
          req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
  	  stat = handle.controlMsg(req, 1, 5)
  	  req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
          
	  if stat[4] == 1 and stat[3] == 1 and stat[2] == 1 and stat[0] ==1 and stat[1] ==1:
              if lv==5:lv=5
	      else: 
                  print "Level 5"
                  lv=5
	      val=0x0105
	      handle.controlMsg(req, 0 , None , value = val)
	      val=0x0101
	      handle.controlMsg(req, 0 , None , value = val)
	      val=0x0102
	      handle.controlMsg(req, 0 , None , value = val)
	      val=0x0103
	      handle.controlMsg(req, 0 , None , value = val)
	      val=0x0100
	      handle.controlMsg(req, 0 , None , value = val)
	  elif stat[3] == 1 and stat[2] == 1 and stat[0] ==1 and stat[1] ==1:
              if lv==4:lv=4
	      else:
                  print "Level 4"
                  lv=4
	      val=0x0103
	      handle.controlMsg(req, 0 , None , value = val)
	      val=0x0100
	      handle.controlMsg(req, 0 , None , value = val)
	      val=0x0102
	      handle.controlMsg(req, 0 , None , value = val)
	      val=0x0101
	      handle.controlMsg(req, 0 , None , value = val)
	      val=0x0005
	      handle.controlMsg(req, 0 , None , value = val)
	  elif stat[2] == 1 and stat[0] ==1 and stat[1] ==1:
              if lv==3:lv=3
	      else:
                  print "Level 3"
                  lv=3
	      val=0x0103
	      handle.controlMsg(req, 0 , None , value = val)
	      val=0x0100
	      handle.controlMsg(req, 0 , None , value = val)
	      val=0x0101
	      handle.controlMsg(req, 0 , None , value = val)
	      val=0x0003
	      handle.controlMsg(req, 0 , None , value = val)
	      val=0x0005
	      handle.controlMsg(req, 0 , None , value = val)
	  elif stat[1] == 1 and stat[0] == 1:
              if lv==2:lv=2
	      else:
                  print "Level 2"
	          lv=2
              val=0x0100
	      handle.controlMsg(req, 0 , None , value = val)
	      val=0x0101
	      handle.controlMsg(req, 0 , None , value = val)
	      val=0x0002
	      handle.controlMsg(req, 0 , None , value = val)
	      val=0x0003
	      handle.controlMsg(req, 0 , None , value = val)
	      val=0x0005
	      handle.controlMsg(req, 0 , None , value = val)
	  elif stat[0] == 1:
              if lv==1:lv=1
	      else:
                  print "Level 1" 
                  lv=1
	      val=0x0101
	      handle.controlMsg(req, 0 , None , value = val)
	      val=0x0000
	      handle.controlMsg(req, 0 , None , value = val)
	      val=0x0002
	      handle.controlMsg(req, 0 , None , value = val)
	      val=0x0003
	      handle.controlMsg(req, 0 , None , value = val)
	      val=0x0005
	      handle.controlMsg(req, 0 , None , value = val)
	  #else : print "The switch is currently ON"
	  #raw_input()

def GetLight():
  req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
  read = handle.controlMsg(req, 2, 2)
  req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
  
  #print read[0],read[1]
  #volt = (read[0]*256)+read[1]
  volt = (((read[0]*256)+read[1])*5)/1023.0
 
  print "%.2f V"%volt
  if(volt>=1.0 and volt<2.0):
      val=0x100
      handle.controlMsg(req, 0 , None , value = val)
  if(volt>=2 and volt<3.0):
      val=0x100
      handle.controlMsg(req, 0 , None , value = val)
      val=0x101
      handle.controlMsg(req, 0 , None , value = val)
  if(volt>=3.0 and volt<4.0):
      val=0x100
      handle.controlMsg(req, 0 , None , value = val)
      val=0x101
      handle.controlMsg(req, 0 , None , value = val)
      val=0x103
      handle.controlMsg(req, 0 , None , value = val)
  if(volt>=4.0 and volt<5.0):
      val=0x100
      handle.controlMsg(req, 0 , None , value = val)
      val=0x101
      handle.controlMsg(req, 0 , None , value = val)
      val=0x102
      handle.controlMsg(req, 0 , None , value = val)
      val=0x103
      handle.controlMsg(req, 0 , None , value = val)
  if(volt==5.0):
      val=0x100
      handle.controlMsg(req, 0 , None , value = val)
      val=0x101
      handle.controlMsg(req, 0 , None , value = val)
      val=0x102
      handle.controlMsg(req, 0 , None , value = val)
      val=0x103
      handle.controlMsg(req, 0 , None , value = val)
      val=0x105
      handle.controlMsg(req, 0 , None , value = val)  
  raw_input()

while (1):
  board = find_board()
  handle = board.open()
  print "------------------------------"
  print "Main Menu(Water Level Warning)"
  print "------------------------------"
  print "1. Test LED"
  print "2. Start"
  print "3. Quit"
  inp = input("Enter choice: ")
  #inp = raw_input()
  if inp == 1:
    SetLED()
  elif inp == 2:
    SwStat()

  elif inp == 3:
    quit()
